﻿using Diagram_MVVMConnectors.GraphSource;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Diagrams;

namespace Diagram_MVVMConnectors.Common
{
	public static class AttachedProperties
	{
		public static RadDiagram Diagram { get; set; }

		public static IEnumerable<ConnectorProxy> GetConnectors(DependencyObject obj)
		{
			return (IEnumerable<ConnectorProxy>)obj.GetValue(ConnectorsProperty);
		}

		public static void SetConnectors(DependencyObject obj, IEnumerable<ConnectorProxy> value)
		{
			obj.SetValue(ConnectorsProperty, value);
		}

		public static readonly DependencyProperty ConnectorsProperty =
			DependencyProperty.RegisterAttached("Connectors", typeof(IEnumerable<ConnectorProxy>), typeof(AttachedProperties), new PropertyMetadata(null, OnConnectorsChanged));

		private static void OnConnectorsChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
		{
			var shape = d as RadDiagramShape;
			// You can also check if the collection is INotifyCollectionChanged if you want to change the connectors runtime.
			// var connectors = e.NewValue as INotifyCollectionChanged
			var connectors = e.NewValue as IEnumerable<ConnectorProxy>;
			if (shape != null && connectors != null)
			{
				//You can remove the default connectors and use only your own or add new to the existing ones.
				shape.UseDefaultConnectors = false;
				foreach (var item in connectors)
				{
					//Note: the item.Name should be a valid x:Name
					shape.Connectors.Add(new RadDiagramConnector() { Name = item.Name, Offset = item.Position });
				}
			}
		}
	}
}
