﻿using System;
using System.Linq;
using Telerik.Windows.Controls;
using Diagram_MVVMConnectors.GraphSource;
using System.Windows;
using Telerik.Windows.Diagrams.Core;

namespace Diagram_MVVMConnectors.ViewModels
{
	public class MainViewModel : ViewModelBase
	{
		private readonly Diagram_MVVMConnectors.GraphSource.GraphSource source;

		public MainViewModel()
		{
			this.source = new Diagram_MVVMConnectors.GraphSource.GraphSource();

			var shape1 = new Node() { Content = "Shape 1", Position = new Point(200, 160) };
			var container = new ContainerNode() { Content = "Container shape", Position = new Point(540, 150) };
			var shape2 = new Node() { Content = "Shape 2", Position = new Point(600, 320) };
			var shape3 = new Node() { Content = "Shape 3", Position = new Point(200, 400) };

			this.source.AddNode(shape1);
			this.source.AddNode(container);
			this.source.AddNode(shape2);
			this.source.AddNode(shape3);

			this.source.AddLink(new Link() { Source = shape1, Target = container, TargetCapType = CapType.Arrow1Filled, SourceConnectorPosition = "FirstConnector", TargetConnectorPosition = "SecondConnector" });
			this.source.AddLink(new Link() { Source = container, Target = shape2, TargetCapType = CapType.Arrow4Filled });
			this.source.AddLink(new Link() { Source = shape2, Target = shape3, TargetCapType = CapType.Arrow3 });
			this.source.AddLink(new Link() { Source = shape3, Target = shape1, TargetCapType = CapType.Arrow6 });
		}

		public Diagram_MVVMConnectors.GraphSource.GraphSource Source
		{
			get
			{
				return this.source;
			}
		}
	}
}
